import 'package:flutter/material.dart';
import 'package:osam/osam.dart';

class Counter {
  Counter([this.value]) {
    value ??= IProperty(0);
  }

  IProperty<int> value;
}

class UseCase2 extends UseCase {
  final Counter counter;

  UseCase2(this.counter);

  void increment() => setValue(counter.value, counter.value.value + 1);
}

void main() {
  final counter = Counter();
  final usecaseContainer = UseCaseContainer([UseCase2(counter)]);

  runApp(Example(
    counter: counter,
    useCaseContainer: usecaseContainer,
  ));
}

class Example extends StatelessWidget {
  final Counter counter;
  final UseCaseContainer useCaseContainer;

  const Example({Key key, this.counter, this.useCaseContainer}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        floatingActionButton: FloatingActionButton(
          child: Icon(Icons.add),
          onPressed: () => useCaseContainer.useCase<UseCase2>().increment(),
        ),
        body: Center(
          child: ValueListenableBuilder(
            valueListenable: counter.value,
            builder: (_, value, __) => Text(
              value.toString(),
              style: const TextStyle(fontSize: 40),
            ),
          ),
        ),
      ),
    );
  }
}
